<?php
// ＜アルゴリズムの注意点＞
// アルゴリズムではこれまでのように調べる力ではなく物事を論理的に考える力が必要です。
// 検索して答えを探して解いても考える力には繋がりません。
// まずは検索に頼らずに自分で処理手順を考えてみましょう。

//また、【その処理が必要かどうか・適切かを考えるため、コメントアウトで一行毎に処理の内容を記述してください。】

//問.ふたつの配列を結合してひとつの配列にする関数を作成してください。
//例)[1, 2, 3]と[a, b, c]という配列→関数の返り値は[1, a, 2, b, 3, c]
<?php
// 二つの配列を交互に結合する関数
function alternateCombine($array1, $array2) {
    $combined = []; // 結合された新しい配列を格納するための空の配列

    // 配列の長さを求める
    $length = max(count($array1), count($array2));

    // 両方の配列から交互に要素を取り出して新しい配列に追加
    for ($i = 0; $i < $length; $i++) {
        if (isset($array1[$i])) {
            // array1の要素を追加
            $combined[] = $array1[$i];
        }
        if (isset($array2[$i])) {
            // array2の要素を追加
            $combined[] = $array2[$i];
        }
    }

    return $combined; // 結合された配列を返す
}

// 関数のテスト
$array1 = [1, 2, 3];
$array2 = ['a', 'b', 'c'];
$result = alternateCombine($array1, $array2);

// 結果の出力
print_r($result);
?>
